#include <stdio.h>
#include <stdlib.h>

#define SRC_LENGTH 7
#define DST_LENGTH 8


char MyBaseMap[10] = {'2', '3', '5', '1', '9', '0', '7', '8', '6', '4'};

//char MyMap[10][10];
char MyReverseMap[10][10] = 
{
//**************index=0*****************
        {'5','3','0','1','9','2','8','6','7','4'},
//*********************************

//**************index=1*****************
        {'4','2','9','0','8','1','7','5','6','3'},
//*********************************

//**************index=2*****************
        {'3','1','8','9','7','0','6','4','5','2'},
//*********************************

//**************index=3*****************
        {'2','0','7','8','6','9','5','3','4','1'},
//*********************************

//**************index=4*****************
        {'1','9','6','7','5','8','4','2','3','0'},
//*********************************

//**************index=5*****************
        {'0','8','5','6','4','7','3','1','2','9'},
//*********************************

//**************index=6*****************
        {'9','7','4','5','3','6','2','0','1','8'},
//*********************************

//**************index=7*****************
        {'8','6','3','4','2','5','1','9','0','7'},
//*********************************

//**************index=8*****************
        {'7','5','2','3','1','4','0','8','9','6'},
//*********************************

//**************index=9*****************
        {'6','4','1','2','0','3','9','7','8','5'},
//*********************************
};

char src[SRC_LENGTH+1];
char dst[DST_LENGTH+1];


void doGenerateMapping(int index)
{
	int i = 0;
	int in;
	for (i = 0; i < 10; i ++)
	{
		in = MyBaseMap[(i + index)%10] - '0';
		MyReverseMap[index][in] = i + '0';
	}
}

void generateMapping()
{
	int i;
	for (i = 0; i < 10; i ++)
	{
		doGenerateMapping(i);
	}
}

void doPrintMapping(int index)
{
	int i;
	printf("\n//**************index=%d*****************\n\t{", index);
	for (i = 0; i < 10; i ++)
	{
		printf("'%c'", MyReverseMap[index][i]);
		if (i != 9)
		{
			printf(",");
		}
		else
		{
			printf("},");
		}
	}
	printf("\n//*********************************\n");

}

void printMapping()
{
	int i=0;
	for (i = 0; i < 10; i ++)
	{
		doPrintMapping(i);
	}
}



void convert(char* src, char* dst, bool isReverse)
{
	int offset, i;

	char* pMyReverseMap;
	
	if (! isReverse)
	{
		offset = src[SRC_LENGTH-1] - '0';
		//offset = 1;
		//////////////////////////////////////
		
		for (i = 0; i < SRC_LENGTH; i ++)
		{
			dst[i] = MyBaseMap[(src[i] - '0' + offset)%10];
		}
		dst[SRC_LENGTH] = offset + '0';
	}
	else
	{
		offset = dst[SRC_LENGTH] -'0';
		//offset = 1;
		pMyReverseMap = MyReverseMap[offset];
		/////////////////////////////
		for (i = 0; i < SRC_LENGTH; i ++)
		{
			src[i] = pMyReverseMap[dst[i] - '0'];
		}
	}
	src[SRC_LENGTH] = dst[DST_LENGTH] = '\0';
}


void doRandomTest()
{
	int i;
	printf("\n******************************\n");
	for (i = 0; i < SRC_LENGTH; i ++)
	{
		src[i] = rand()%10 + '0';
	}
	src[SRC_LENGTH] = '\0';

	convert(src, dst, false);

	printf("converting: src[%s],dst[%s]\n", src, dst);

	convert(src, dst, true);

	printf("converting back: src[%s],dst[%s]\n", src, dst);
	printf("\n******************************\n");
}


void randomTest()
{
	//generateMapping();
	//printMapping();
	for (int i =0; i< 10; i ++)
	{
		doRandomTest();
	}
}

void test1()
{
	sprintf(src, "1234567");
	convert(src, dst, false);
	printf("converting: src[%s],dst[%s]\n", src, dst);

	convert(src, dst, true);

	printf("converting back: src[%s],dst[%s]\n", src, dst);
	printf("\n******************************\n");
}

int main(int argc, char** argv)
{
	randomTest();
	test1();
	return 0;
}


